#ifndef _IDT_
#define _IDT_

/**
 * Structure for an IDT entry
 */
struct IdtEntry {
	unsigned short baseLow;
	unsigned short kernelSegment;
	unsigned char zero;
	unsigned char flags;
	unsigned short baseHigh;
}__attribute__((packed));

/**
 * Structure of the IDT pointer
 */
struct IdtPointer {
	unsigned short limit;
	unsigned int base;
}__attribute__((packed));

class Idt {
public:
	void install();
	void createIdtGate(unsigned char index, unsigned int base,
			unsigned short kernelSegment, unsigned char flags);
};

#endif
